//**********************************************************************************************
// Declaration des entetes et prototypes
//**********************************************************************************************
	#include 	"..\h\Main.h"      		// Required
//**********************************************************************************************






//******************************************************************************
// Calcul de la tension de chaque Accu
//******************************************************************************
void CalculTensionAccu(void)
{
	if(Charge == 1)											// Mode chargeur
	{
		TensionAccu[0]		= Valim15VMoyAmpli - Vaccu4MoyAmpli;		// Accu entier
		if(Vaccu1MoyAmpli < Vaccu4MoyAmpli)
		{
			TensionAccu[1]		= 0;		// Element 1
		}
		else
		{
			TensionAccu[1]		= Vaccu1MoyAmpli - Vaccu4MoyAmpli;		// Element 1 
		}
		
		if(Vaccu1MoyAmpli < Vaccu4MoyAmpli)
		{
			TensionAccu[2]		= 0;		// Element 2
		}
		else
		{
			TensionAccu[2]		= Vaccu2MoyAmpli - Vaccu1MoyAmpli;		// Element 2  
		}
			
		if(Vaccu1MoyAmpli < Vaccu4MoyAmpli)
		{
			TensionAccu[3]		= 0;		// Element 3
		}
		else
		{
			TensionAccu[3]		= Vaccu3MoyAmpli - Vaccu2MoyAmpli;		// Element 3
		}
			
		if(Vaccu1MoyAmpli < Vaccu4MoyAmpli)
		{
			TensionAccu[4]		= 0;		// Element 4
		}
		else
		{
			TensionAccu[4]		= Valim15VMoyAmpli - Vaccu3MoyAmpli;		// Element 4
		}
	}
	else													// mode dechargeur
	{
		TensionAccu[0]		= Vaccu4MoyAmpli;
		TensionAccu[1]		= Vaccu4MoyAmpli - Vaccu3MoyAmpli;		// Element 1 
		TensionAccu[2]		= Vaccu3MoyAmpli - Vaccu2MoyAmpli;		// Element 2 
		TensionAccu[3]		= Vaccu2MoyAmpli - Vaccu1MoyAmpli;		// Element 3 
		TensionAccu[4]		= Vaccu1MoyAmpli;						// Element 4
	}
}
//******************************************************************************








//******************************************************************************
// Sauvegarde tension de chaque Accu
//******************************************************************************
void SauvegardeTensionAccu(void)
{
	NumSauvegarde 		= 21;
	BatSauvegardeConvPourUSB(TensionAccu[0]);
		
	NumSauvegarde 		= 33;
	BatSauvegardeConvPourUSB(TensionAccu[1]);

	NumSauvegarde 		= 36;
	BatSauvegardeConvPourUSB(TensionAccu[2]);

	NumSauvegarde 		= 39;
	BatSauvegardeConvPourUSB(TensionAccu[3]);

	NumSauvegarde 		= 42;
	BatSauvegardeConvPourUSB(TensionAccu[4]);

	NumSauvegarde 		= 24;
	BatSauvegardeConvPourUSB((TensionAccuMax[0]));

	NumSauvegarde 		= 27;
	BatSauvegardeConvPourUSB((TensionAccuMax[1]));

	NumSauvegarde 		= 30;
	BatSauvegardeConvPourUSB(TensionAccuMax[2]);

	NumSauvegarde 		= 46;
	BatSauvegardeConvPourUSB((TensionAccuMax[3]));

	NumSauvegarde 		= 49;
	BatSauvegardeConvPourUSB((TensionAccuMax[4]));
}
//******************************************************************************





//******************************************************************************
// Recherche des Accus charger
//******************************************************************************
void ChercheAccuCharge(void)
{
	static unsigned char i;
	
	for(i=0;i<5;i++)
	{
		if(TensionAccu[i] > TensionAccuMax[i])
		{
			TensionAccuMax[i] = TensionAccu[i];
		}
	}
	
	if(Charge == 1)
	{
		for(i=1;i<5;i++)
		{
			if(TensionAccu[i] < (TensionAccuMax[i] - OffsetChargeElt))
			{
				AutoriseLed	= 0;		// Element charge
				ObjectifAtteint = i;	// numero de l'element de l'accu charg
				CompteurLedMax = ObjectifAtteint * 2;
				BatChangePwm(0);		// Annule le courant de charge
			}
		}
	
		if(TensionAccu[0] < (TensionAccuMax[0] - OffsetCharge))
		{
			AutoriseLed	= 0;			// Accu charge
			ObjectifAtteint = 5;		// 5 pour indiquer accu complet
			CompteurLedMax = ObjectifAtteint * 2;
			BatChangePwm(0);			// Annule le courant de charge
		}
		else
		{
			
		}
	}
	
	ResultatConv[45] = ObjectifAtteint + 10;
}
//******************************************************************************






