//**********************************************************************************************
// Declaration des entetes et prototypes
//**********************************************************************************************
	#include 	"..\h\Main.h"      		// Required
//**********************************************************************************************





//**********************************************************************************
// Initialisation des variables
//**********************************************************************************
void BatInitVariableFiltrage(void)
{
	static unsigned char i,j;
	
	INTCONbits.GIE 		= 0;			// Interdiction interruptions globales
	
	PremiereAcquisition = 0;
	AutoriseLed			= 1;
	NumAcquisition 		= 1;
	CptNbAcquisition	= 0;			// Horloge : temps coul en nombre de periode d'acquisition
	BatSelectionVoieAdc(VoieMesAccu1);
	
	Valim15VMoyAmpli	= 0;
	Vaccu1MoyAmpli		= 0;
	Vaccu2MoyAmpli		= 0;
	Vaccu3MoyAmpli		= 0;
	Vaccu4MoyAmpli		= 0;
	VcourantMoy			= 0;
	
	
	CompteurTemps		= 0;
	CptLedRouge			= 0;
	CptLedVerte			= 0;
	
	ObjectifAtteint		= 0;
	
	for(i=0;i<=5;i++)
	{
		TensionAccu[i] = 0;
		TensionAccuMax[i] = 0;
		TensionAccuCharge = 0;
	}
	
	for(i=0;i<52;i++)
	{
		ResultatConv[i] = 0x30;
	}
	
	ResultatConv[45] 	= 10;			// Accu dcharg
	
	NbTotalOctetUSB = 52;
	
	INTCONbits.GIE 		= 1;			// Autorisation interruptions globales
}
//**********************************************************************************





//**********************************************************************************
// Calcul de valeur moyenne
//**********************************************************************************
unsigned long BatValeurMoyenne(unsigned long MoyPrecAmpli, unsigned long ValeurAmpli)
{
	static unsigned long Tampon;
	
	if(ValeurAmpli >= MoyPrecAmpli)
	{
		Tampon = MoyPrecAmpli + 1;
	}
	else
	{
		Tampon = MoyPrecAmpli;
	}
	Tampon = (CoefMoyenneur - 1) * Tampon;
	Tampon = Tampon + ValeurAmpli;
	Tampon = Tampon / (CoefMoyenneur);

	return(Tampon);
}
//**********************************************************************************






//**********************************************************************************
// Filtrage et sauvegarde des mesures
//**********************************************************************************
void FiltrageEtSauvegarde(void)
{
	static unsigned long Tmp;
	
	if(PremiereAcquisition < 4)
	{
		PremiereAcquisition = PremiereAcquisition + 1;
		
		ResulConvAN			= (Vaccu1 );
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu1MoyAmpli		= Tmp;
		NumSauvegarde 		= 0;
		BatSauvegardeConvPourUSB(Vaccu1MoyAmpli);
		
		ResulConvAN			= (Vaccu2 );
		Tmp					= BatCorrigeConversion(CorrectionAccu2);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu2MoyAmpli		= Tmp;
		NumSauvegarde 		= 3;
		BatSauvegardeConvPourUSB(Vaccu2MoyAmpli);
		
		ResulConvAN			= (Vaccu3 );
		Tmp					= BatCorrigeConversion(CorrectionAccu3);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu3MoyAmpli		= Tmp;
		NumSauvegarde 		= 6;
		BatSauvegardeConvPourUSB(Vaccu3MoyAmpli);
		
		ResulConvAN			= (Vaccu4 );
		Tmp					= BatCorrigeConversion(CorrectionAccu4);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu4MoyAmpli		= Tmp;
		NumSauvegarde 		= 9;
		BatSauvegardeConvPourUSB(Vaccu4MoyAmpli);

		ResulConvAN			= (Valim15 );
		Tmp					= BatCorrigeConversion(CorrectionAlim15);
		Tmp					= Tmp * CoefAmplificateur;
		Valim15VMoyAmpli	= Tmp;
		NumSauvegarde 		= 12;
		BatSauvegardeConvPourUSB(Valim15VMoyAmpli);

		ResulConvAN			= (Vcourant );
		Tmp					= BatCorrigeConversion(CorrectionCourant);
		Tmp					= Tmp * CoefAmplificateur;
		VcourantMoy			= Tmp;
		NumSauvegarde 		= 15;
		BatSauvegardeConvPourUSB(VcourantMoy);

		Tmp					= (VtempAccu);
		Tmp					= Tmp * CoefAmplificateur;
		VtempAccuMoy		= Tmp;
		NumSauvegarde 		= 18;
		BatSauvegardeConvPourUSB(VtempAccuMoy);
		
			Valim15VMoyAmpli	= Valim15VMoyAmpli * 123;
			Valim15VMoyAmpli	= Valim15VMoyAmpli / 128;
			
			Vaccu3MoyAmpli		= Vaccu3MoyAmpli * 124;
			Vaccu3MoyAmpli		= Vaccu3MoyAmpli / 128;
			
			Vaccu2MoyAmpli		= Vaccu2MoyAmpli * 125;
			Vaccu2MoyAmpli		= Vaccu2MoyAmpli / 128;
			
			Vaccu1MoyAmpli		= Vaccu1MoyAmpli * 126;
			Vaccu1MoyAmpli		= Vaccu1MoyAmpli / 128;
			
			Vaccu4MoyAmpli		= Vaccu4MoyAmpli * 127;
			Vaccu4MoyAmpli		= Vaccu4MoyAmpli / 128;
	}
	else
	{
		PremiereAcquisition = PremiereAcquisition + 1;
		if(PremiereAcquisition > 2500)
		{
			PremiereAcquisition = 2510;
		}
		ResulConvAN			= Vaccu1;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu1MoyAmpli		= BatValeurMoyenne(Vaccu1MoyAmpli, Tmp);
		NumSauvegarde 		= 0;
		BatSauvegardeConvPourUSB(Vaccu1MoyAmpli);
		
		ResulConvAN			= Vaccu2;
		Tmp					= BatCorrigeConversion(CorrectionAccu2);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu2MoyAmpli		= BatValeurMoyenne(Vaccu2MoyAmpli, Tmp);
		NumSauvegarde 		= 3;
		BatSauvegardeConvPourUSB(Vaccu2MoyAmpli);
		
		ResulConvAN			= Vaccu3;
		Tmp					= BatCorrigeConversion(CorrectionAccu3);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu3MoyAmpli		= BatValeurMoyenne(Vaccu3MoyAmpli, Tmp);
		NumSauvegarde 		= 6;
		BatSauvegardeConvPourUSB(Vaccu3MoyAmpli);
		
		ResulConvAN			= Vaccu4;
		Tmp					= BatCorrigeConversion(CorrectionAccu4);
		Tmp					= Tmp * CoefAmplificateur;
		Vaccu4MoyAmpli		= BatValeurMoyenne(Vaccu4MoyAmpli, Tmp);
		NumSauvegarde 		= 9;
		BatSauvegardeConvPourUSB(Vaccu4MoyAmpli);

		ResulConvAN			= Valim15;
		Tmp					= BatCorrigeConversion(CorrectionAlim15);
		Tmp					= Tmp * CoefAmplificateur;
		Valim15VMoyAmpli	= BatValeurMoyenne(Valim15VMoyAmpli, Tmp);
		NumSauvegarde 		= 12;
		BatSauvegardeConvPourUSB(Valim15VMoyAmpli);

		ResulConvAN			= Vcourant;
		Tmp					= BatCorrigeConversion(CorrectionCourant);
		Tmp					= Tmp * CoefAmplificateur;
		VcourantMoy			= BatValeurMoyenne(VcourantMoy, Tmp);
		NumSauvegarde 		= 15;
		BatSauvegardeConvPourUSB(VcourantMoy);

		Tmp					= VtempAccu * CoefAmplificateur;
		VtempAccuMoy		= BatValeurMoyenne(VtempAccuMoy, Tmp);
		NumSauvegarde 		= 18;
		BatSauvegardeConvPourUSB(VtempAccuMoy);
	}
}
//**********************************************************************************






