//**********************************************************************************************
// Declaration des entetes et prototypes
//**********************************************************************************************
	#include 	"..\h\Main.h"      		// Required
//**********************************************************************************************



//**********************************************************************************
// Configuration du PWM utilisant le comparateur 1 et le timer 2 : bit RC2
//**********************************************************************************
void BatInitPwm(void)
{
	TRISCbits.TRISC2 = 0;		// Bit RC2 en sortie
	
	BatInitTimer2();			// Initialisation du Timer 2
	
	PR2 = 0xFF;					// Periode du PWM = 1024 cyc soit Fpwm = 39 kHz
								// avec Fosc = 40 MHz
							
	CCP1CON = 0x0C;				// Comparateur 1 en mode PWM sortie RC2
	
	CCPR1L = 0x00;				// 8 bits de poids fort pour largeur d'impulsion
	CCP1CONbits.DC1B1 = 0;		// 2 bits de poids faible
	CCP1CONbits.DC1B0 = 0;
}
//**********************************************************************************


//**********************************************************************************
// Chgangement de la valeur du PWM utilisant le comparateur 1 : bit RC2
//**********************************************************************************
void BatChangePwm(unsigned long ValeurPwm)
{
	static unsigned int Tampon;
	
	Tampon 	= ValeurPwm & 0x000003FF;
	Ipwm	= Tampon;
	
	CCP1CONbits.DC1B1 = 0;				// 2 bits de poids faible
	CCP1CONbits.DC1B0 = 0;
	
	if(Tampon & 0x00000001)
	{
		CCP1CONbits.DC1B1 = 1;			// 2 bits de poids faible
	}

	if((Tampon & 0x00000002) == 0x00000002)
	{
		CCP1CONbits.DC1B0 = 1;
	}

	Tampon = Tampon >> 2;				// 8 bits de poids fort pour largeur d'impulsion
	CCPR1L = Tampon;
}
//**********************************************************************************

