//**********************************************************************************************
// Declaration des entetes et prototypes
//**********************************************************************************************
	#include 	"..\h\Main.h"      		// Required
//**********************************************************************************************





//**********************************************************************************
// Initialisation des variables
//**********************************************************************************
void BatInitVariableFiltrage(void)
{
	static unsigned int Tmp;
	static unsigned char i,j;
	
	INTCONbits.GIE 		= 0;			// Interdiction interruptions globales
	
	PremiereAcquisition = 0;
	AutoriseLed			= 1;
	NumAcquisition 		= 1;
	BatSelectionVoieAdc(VoieMesAccu1);	// Selection de la Voie de mesure pour le filtrage numerique
										// Voir dans fichier Main.h
	
	Valim15VMoyAmpli	= 0;
	Vaccu1MoyAmpli		= 0;
	Vaccu2MoyAmpli		= 0;
	Vaccu3MoyAmpli		= 0;
	Vaccu4MoyAmpli		= 0;
	VcourantMoy			= 0;
	VtempAccuMoy		= 0;
	
	
	CompteurTemps		= 0;
	CptLedRouge			= 0;
	CptLedVerte			= 0;
	
	ObjectifAtteint		= 0;
	
	Tmp 	= DureeAcquisition;
	Tmp 	= Tmp >> 8;
	Tmp 	= Tmp & 0x00FF;
	Th		= Tmp;
	
	Tmp 	= DureeAcquisition;
	Tmp 	= Tmp & 0x00FF;
	Tb		= Tmp;
	
/*	for(i=0;i<=5;i++)
	{
		TensionAccu[i] = 0;
		TensionAccuMax[i] = 0;
		TensionAccuCharge = 0;
	}
*/	
	for(i=0;i<52;i++)
	{
		ResultatConv[i] = 0x30;
	}
	
	ResultatConv[45] 	= 10;			// Accu dcharg
	
	NbTotalOctetUSB = 52;
	
	INTCONbits.GIE 		= 1;			// Autorisation interruptions globales
}
//**********************************************************************************



//**********************************************************************************
// Initialisation des variables
//**********************************************************************************
void BatInitCoefFiltrage(void)
{
	CoeffAmpl[1]		= CoefAmplificateur1;
	CoeffAmpl[2]		= CoefAmplificateur2;
	CoeffAmpl[3]		= CoefAmplificateur3;
	CoeffAmpl[4]		= CoefAmplificateur4;
	CoeffAmpl[5]		= CoefAmplificateur5;
	CoeffAmpl[6]		= CoefAmplificateur6;
	CoeffAmpl[7]		= CoefAmplificateur7;
	
	CoeffMoy[1]			= CoefMoyenneur1;
	CoeffMoy[2]			= CoefMoyenneur2;
	CoeffMoy[3]			= CoefMoyenneur3;
	CoeffMoy[4]			= CoefMoyenneur4;
	CoeffMoy[5]			= CoefMoyenneur5;
	CoeffMoy[6]			= CoefMoyenneur6;
	CoeffMoy[7]			= CoefMoyenneur7;

}
//**********************************************************************************







//**********************************************************************************
// Filtrage et sauvegarde des mesures
//**********************************************************************************
void FiltrageEtSauvegarde(void)
{
	static unsigned long Tmp;
	
	PremiereAcquisition = 2510;
	if(PremiereAcquisition < 5)
	{
		PremiereAcquisition = PremiereAcquisition + 1;

		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[1];
		Vaccu1MoyAmpli		= Tmp;
		NumSauvegarde 		= 0;
		BatSauvegardeConvPourUSB(Vaccu1MoyAmpli);
		
		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionAccu2);
		Tmp					= Tmp * CoeffAmpl[2];
		Vaccu2MoyAmpli		= Tmp;
		NumSauvegarde 		= 3;
		BatSauvegardeConvPourUSB(Vaccu2MoyAmpli);
		
		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionAccu3);
		Tmp					= Tmp * CoeffAmpl[3];
		Vaccu3MoyAmpli		= Tmp;
		NumSauvegarde 		= 6;
		BatSauvegardeConvPourUSB(Vaccu3MoyAmpli);
		
		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionAccu4);
		Tmp					= Tmp * CoeffAmpl[4];
		Vaccu4MoyAmpli		= Tmp;
		NumSauvegarde 		= 9;
		BatSauvegardeConvPourUSB(Vaccu4MoyAmpli);

		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionAlim15);
		Tmp					= Tmp * CoeffAmpl[5];
		Valim15VMoyAmpli	= Tmp;
		NumSauvegarde 		= 12;
		BatSauvegardeConvPourUSB(Valim15VMoyAmpli);

		ResulConvAN			= (Velement & 0x03fc);
		Tmp					= BatCorrigeConversion(CorrectionCourant);
		Tmp					= Tmp * CoeffAmpl[6];
		VcourantMoy			= Tmp;
		NumSauvegarde 		= 15;
		BatSauvegardeConvPourUSB(VcourantMoy);

		Tmp					= (Velement & 0x03fc);
		Tmp					= Tmp * CoeffAmpl[7];
		VtempAccuMoy		= Tmp;
		NumSauvegarde 		= 18;
		BatSauvegardeConvPourUSB(VtempAccuMoy);

		NumSauvegarde 		= 21;
		BatSauvegardeConvPourUSB(Velement);
	}
	else
	{
		PremiereAcquisition = PremiereAcquisition + 1;
		if(PremiereAcquisition > 2500)
		{
			PremiereAcquisition = 2510;
		}
		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[1];
		Vaccu1MoyAmpli		= BatValeurMoyenne1(Vaccu1MoyAmpli, Tmp);
		NumSauvegarde 		= 0;
		BatSauvegardeConvPourUSB(Vaccu1MoyAmpli);
		
		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[2];
		Vaccu2MoyAmpli		= BatValeurMoyenne2(Vaccu2MoyAmpli, Tmp);
		NumSauvegarde 		= 3;
		BatSauvegardeConvPourUSB(Vaccu2MoyAmpli);
		
		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[3];
		Vaccu3MoyAmpli		= BatValeurMoyenne3(Vaccu3MoyAmpli, Tmp);
		NumSauvegarde 		= 6;
		BatSauvegardeConvPourUSB(Vaccu3MoyAmpli);
		
		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[4];
		Vaccu4MoyAmpli		= BatValeurMoyenne4(Vaccu4MoyAmpli, Tmp);
		NumSauvegarde 		= 9;
		BatSauvegardeConvPourUSB(Vaccu4MoyAmpli);

		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[5];
		Valim15VMoyAmpli	= BatValeurMoyenne5(Valim15VMoyAmpli, Tmp);
		NumSauvegarde 		= 12;
		BatSauvegardeConvPourUSB(Valim15VMoyAmpli);

		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[6];
		VcourantMoy			= BatValeurMoyenne6(VcourantMoy, Tmp);
		NumSauvegarde 		= 15;
		BatSauvegardeConvPourUSB(VcourantMoy);

		ResulConvAN			= Velement;
		Tmp					= BatCorrigeConversion(CorrectionAccu1);
		Tmp					= Tmp * CoeffAmpl[7];
		VtempAccuMoy		= BatValeurMoyenne7(VtempAccuMoy, Tmp);
		NumSauvegarde 		= 18;
		BatSauvegardeConvPourUSB(VtempAccuMoy);

		NumSauvegarde 		= 21;
		BatSauvegardeConvPourUSB(Velement);
	}
}
//**********************************************************************************






