//**********************************************************************************************
// Declaration des entetes et prototypes
//**********************************************************************************************
	#include 	"..\h\Main.h"      		// Required
//**********************************************************************************************






//**********************************************************************************
// Initialisation du Timer 0
// Utilis pour lancer les conversions AN toutes les 250 ms
//**********************************************************************************
void BatInitTimer0(void)
{
	T0CONbits.T08BIT 	= 0;		// Mode 16 bits
	
	T0CONbits.T0CS 		= 0;		// Horloge interne oscillateur
	
	T0CONbits.PSA 		= 1;		// Pas de Activation de predivision
	T0CONbits.T0PS2 	= 1;
	T0CONbits.T0PS1 	= 0;
	T0CONbits.T0PS0 	= 0;		// Predivision par 32
	
	T0CONbits.TMR0ON 	= 1;		// Mise en route du Timer 0
	
	INTCON2bits.TMR0IP 	= 1;		// Interrupt prioritaire
	INTCONbits.TMR0IF 	= 0;		// Init du bit de depassement
	INTCONbits.TMR0IE 	= 1;		// Validation interruption du Timer 0
}
//**********************************************************************************






//**********************************************************************************
// Initialisation du Timer 1
// Non utilis
//**********************************************************************************
void BatInitTimer1(void)
{
	T1CONbits.RD16 = 1;			// 1 registre de 16 bits
	
	T1CONbits.T1OSCEN = 0;		// Horloge du C genere par le quartz
	
	T1CONbits.TMR1CS = 0;		// Horloge interne du microcontroleur
	
	T1CONbits.T1CKPS1 = 0;		// 
	T1CONbits.T1CKPS0 = 0;		// Pas de predivision

	T1CONbits.TMR1ON = 1;		// Mise ne route du Timer 1
	
	PIE1bits.TMR1IE = 0;		// Interdiction interruption du Timer 1
	IPR1bits.TMR1IP = 0;		// Interrupt non prioritaire
	PIR1bits.TMR1IF = 0;		// Init du bit de depassement
}
//**********************************************************************************








//**********************************************************************************
// Initialisation du Timer 2
// Utiliser pour le PWM
//**********************************************************************************
void BatInitTimer2(void)
{
	T2CONbits.T2CKPS1 	= 0;		// 
	T2CONbits.T2CKPS0 	= 0;		// Predivision par 1

	T2CONbits.TMR2ON 	= 1;		// Mise ne route du Timer 2
	
	PIE1bits.TMR2IE 	= 0;		// Interdiction interruption du Timer 2
	IPR1bits.TMR2IP 	= 0;		// Interrupt non prioritaire
	PIR1bits.TMR2IF 	= 0;		// Init du bit de depassement
}
//**********************************************************************************






//**********************************************************************************
// Initialisation du Timer 3
// Non utilis
//**********************************************************************************
void BatInitTimer3(void)
{
	T3CONbits.RD16 = 0;			// 2 registres de 8 bits
	
	T3CONbits.TMR3CS = 0;		// Horloge interne oscillateur
	
	T3CONbits.T3CKPS1 = 1;		// 
	T3CONbits.T3CKPS0 = 1;		// Predivision par 8

	T3CONbits.TMR3ON = 1;		// Mise ne route du Timer 3
	
	IPR2bits.TMR3IP = 0;		// Interrupt non prioritaire
	PIR2bits.TMR3IF = 0;		// Init du bit de depassement
	PIE2bits.TMR3IE = 0;		// Interdiction interruption du Timer 3
}
//**********************************************************************************




