//*****************************************************************************************
// Declaration des Entetes et variables
// Commande du Variateur de Vitesse/control driver ???
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************









//**********************************************************************************
// Configuration du convetisseur Analogique Numerique
//**********************************************************************************
void InitAdc(void)
{
	// Choix des tensions de reference
	ADCON0bits.VCFG1 			= 0;				// Vref- = GND
	ADCON0bits.VCFG0 			= 0;				// Vref+ = VDD

	// Realisation du temps Tad = 1.6 s avec quartz 10 MHz et PLL
	ADCON2bits.ADCS2 			= 1;
	ADCON2bits.ADCS1 			= 1;
	ADCON2bits.ADCS0 			= 0;				// Fosc/64 = 40 MHz / 64 = 1.6 s
	
	// Temps d'acquisition
	ADCON2bits.ACQT2 			= 1;
	ADCON2bits.ACQT1 			= 0;
	ADCON2bits.ACQT0 			= 0;				// Temps acquisition = 8 Tad

	ADCON2bits.ADFM 			= 1;				// Justification  droite du resultat de conversion
	
	ADCON0bits.CHS2 			= 0;				// Selection Voie 0 pour la conversion AN
	ADCON0bits.CHS1 			= 0;
	ADCON0bits.CHS0 			= 0;
	
	ADCON1bits.PCFG0			= 0;				// Bit 0 en analogique
	
	ADCON0bits.ADON 			= 1;				// Mise en route du convertisseur
	
	PIR1bits.ADIF 				= 0;				// Init du bit de depassement
	IPR1bits.ADIP 				= 0;				// Interrupt non prioritaire
	PIE1bits.ADIE 				= 0;				// Interdiction interruption du convertisseur AN
}
//**********************************************************************************










//**********************************************************************************
// Recuperation de la conversion AN
//**********************************************************************************
void RecupereConversionAdc(void)
{
	PIR1bits.ADIF 		= 0;							// Init du bit de fin de conversion
	ADCON0bits.GO 		= 1;							// Lance la conversion

	while(ADCON0bits.GO == 1);							// Attend la fin de la conversion
	
	PositionAJ1			= ADRESH;
	PositionAJ1			= PositionAJ1 << 8;
	PositionAJ1			= PositionAJ1 + ADRESL;
	
	ModificationVitesse();
}
//**********************************************************************************









//**********************************************************************************
// Modification de la vitesse moteur en modifiant le PWM sur le pont en H
//**********************************************************************************
void ModificationVitesse(void)
{
	static unsigned char 	SensMoteur;
	static unsigned long 	VitesseMoteur;
	static unsigned int 	Tampon;
	
	if(PositionAJ1 > (PositionAJ1Neutre + Hysteresis))					// Marche avant
	{
			SensMoteur 		= 0;
			VitesseMoteur 	= PositionAJ1 - PositionAJ1Neutre - Hysteresis;
			VitesseMoteur 	= VitesseMoteur * 512;
			Tampon			= 1024 - PositionAJ1Neutre - Hysteresis;
			VitesseMoteur 	= VitesseMoteur / (1024 - PositionAJ1Neutre - Hysteresis);
			
			//VitesseMoteur 	= PositionAJ1 - 512;
	}
	else											
	{
		if(PositionAJ1 < (PositionAJ1Neutre - Hysteresis))				// Marche arriere
		{
			SensMoteur 		= 1;
			VitesseMoteur 	= PositionAJ1Neutre - Hysteresis - PositionAJ1;
			VitesseMoteur 	= VitesseMoteur * (PositionAJ1Neutre - Hysteresis);
			VitesseMoteur 	= VitesseMoteur / 512;
			
			//VitesseMoteur 	= 511 - PositionAJ1;
		}
		else
		{
			VitesseMoteur 	= 0;						// Vitesse Nulle
		}
	}
	VitessePwm(SensMoteur, VitesseMoteur);				// Modification du PWM donc vitesse moteur
}
//**********************************************************************************



