//*****************************************************************************************
// Declaration des Entetes et variables
// Commande du Variateur de Vitesse/control driver ???
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************










//**********************************************************************************
// Initialisation du Timer 2
// Utiliser pour le PWM
//**********************************************************************************
void InitTimer2(void)
{
	T2CONbits.T2CKPS1 	= 1;		// 
	T2CONbits.T2CKPS0 	= 1;		// Predivision par 16

	T2CONbits.TMR2ON 	= 1;		// Mise ne route du Timer 2
	
	PIR1bits.TMR2IF 	= 0;		// Init du bit de depassement
	IPR1bits.TMR2IP 	= 0;		// Interrupt non prioritaire
	PIE1bits.TMR2IE 	= 0;		// Interdiction interruption du Timer 2
}
//**********************************************************************************



//**********************************************************************************
// Configuration du PWM utilisant le comparateur 1 et le timer 2
//**********************************************************************************
void InitPwm(void)
{
	InitTimer2();					// Initialisation du Timer 2
	
	SensP1A 			= 0;		// P1A en mode sortie
	SensP1B 			= 0;		// P1B en mode sortie
	SensP1C 			= 0;		// P1C en mode sortie
	SensP1D 			= 0;		// P1D en mode sortie
	
	PR2 				= 0xFF;		// Periode du PWM = ?
									// avec Fosc = 40 MHz
	
	PWM1CONbits.PRSEN 	= 0;		// 
	ECCPAS				= 0;		// Pas d'utilisation de l'auto Shut Down
							
	CCP1CONbits.CCP1M3 	= 1;		// 
	CCP1CONbits.CCP1M2 	= 1;		// Comparateur en mode PWM
	
	CCP1CONbits.CCP1M1 	= 0;		// 
	CCP1CONbits.CCP1M0 	= 0;		// Etat actif des transistors  l'etat haut
	
	VitessePwm(1, 0x0000);			// Initialisation de la vitesse
	
	PIE1bits.CCP1IE 	= 0;		// Interruption non autorise
}
//**********************************************************************************









//**********************************************************************************
// Changement du rapport cyclique du PWM et de la commande des transistors
//**********************************************************************************
void VitessePwm(unsigned char SensPwm, unsigned long Vitesse)
{
	static unsigned int Vit;
	
	if(SensPwm == 0)					// Marche avant
	{
		// Modification du sens du moteur
		CCP1CONbits.P1M1 	= 0;		// 0 = Marche avant
		CCP1CONbits.P1M0 	= 1;		// 
	}
	else								// Marche arriere
	{
		// Modification du sens du moteur
		CCP1CONbits.P1M1 	= 1;		// 1 = Marche arriere
		CCP1CONbits.P1M0 	= 1;		// 
	}
	
	if(Vitesse == 0)
	{
		CCP1CONbits.CCP1M3 	= 0;		// Inhibition du PWM
		CCP1CONbits.CCP1M2 	= 0;		// 
	
		CCP1CONbits.CCP1M1 	= 0;		// 
		CCP1CONbits.CCP1M0 	= 0;		// 
		
		// Config en Freinage pour l'arret de la voiture
		P1B					= 0;		// L1
		P1D					= 0;		// L2
		P1A					= 1;		// H1
		P1C					= 1;		// H2
		
		// Config en Roue libre pour l'arret de la voiture
		//P1B					= 0;		// L1
		//P1D					= 0;		// L2
		//P1A					= 0;		// H1
		//P1C					= 0;		// H2
	}
	else
	{
		CCP1CONbits.CCP1M3 	= 1;		// 
		CCP1CONbits.CCP1M2 	= 1;		// Comparateur en mode PWM
	
		CCP1CONbits.CCP1M1 	= 0;		// 
		CCP1CONbits.CCP1M0 	= 0;		// Etat actif des transistors  l'etat haut
		
		Vitesse = Vitesse / CoefReducVitesse;		// Reduction vitesse pour essai indoor
		
		// Modification de la vitesse du moteur
		if((Vitesse & 0x0001) == 0x0001)
		{
			CCP1CONbits.DC1B1 = 1;	// 1er Bit de poids faible
		}
		else
		{
			CCP1CONbits.DC1B1 = 0;	// 1er Bit de poids faible
		}
	
		CCP1CONbits.DC1B0 = 0;
	}
	
	Vit 			= Vitesse;
	Vit 			= (Vit >> 1);
	CCPR1L 			= Vit;				// 8 bits de poids fort pour largeur d'impulsion
}
//**********************************************************************************





