//*****************************************************************************************
// Declaration des Entetes et variables
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************




//*************************************************************************************************************
// Dclaration d'instruction en assembleur dans le C
//*************************************************************************************************************
#pragma code int_prioritaire=0x0008
void interrupt_at_high_vector(void)
{
	_asm GOTO Int_niveau_fort _endasm
}

#pragma code int_non_prioritaire=0x0018
void interrupt_at_low_vector(void)
{
	_asm GOTO Int_niv_faible _endasm
}
//*************************************************************************************************************



#pragma code 								// Retour au code programme en C
#pragma interrupt 		Int_niveau_fort 	nosave=section(".tmpdata"),section("MATH_DATA"),TABLAT,PROD,TBLPTR
#pragma interruptlow 	Int_niv_faible 		nosave=section(".tmpdata"),section("MATH_DATA"),TABLAT,PROD,TBLPTR

//*************************************************************************************************************
// Interruption de niveau fort
//*************************************************************************************************************
void Int_niveau_fort(void)
{
	if(INTCONbits.INT0IF == 1)								// Reception du signal PPM servo moteur
	{
		TempsPpmL 				= TMR0L;
		TempsPpm 				= TMR0H;
		TMR0H 					= 0;
		TMR0L 					= 0;
		TempsPpm 				= (TempsPpm << 8);
		TempsPpm 				= (TempsPpm + TempsPpmL);
		
		LedRouge				= 0;							// Eteint la led rouge Detection signal PPM
		CptDepassementTimer0 	= 0;
		AcquisitionCalcule();									// Calcule la dure de l'impulsion recue et change la vitesse du moteur
		
		INTCON2bits.INTEDG0		= !INTCON2bits.INTEDG0;			// Changement du front de detection
		INTCONbits.INT0IF 		= 0;							// Init pour la nouvelle detection
	}
}
//*************************************************************************************************************




//*************************************************************************************************************
// Interruption de niveau faible
//*************************************************************************************************************
void Int_niv_faible(void)
{
	if(PIR1bits.ADIF == 1)								// Fin de conversion AN
	{
		RecupereConversionAdc();						// recupere le resultat de la conversion AN
		PIR1bits.ADIF		= 0;
	}


	if(INTCONbits.TMR0IF == 1)							// Depassement Timer 0
	{
		CptDepassementTimer0 = CptDepassementTimer0 + 1;
		if(CptDepassementTimer0 > 5)
		{
			LedRouge				= 1;				// Allume la led rouge Perte signal PPM
			CptDepassementTimer0 	= 5;
			VitessePwm(0, 0);							// Arret des moteurs, Perte Signal PPM
		}
		INTCONbits.TMR0IF = 0;
	}

	if(PIR1bits.TMR1IF == 1)							// Lance la prochaine conversion AN
	{
		TMR1H				= DureeTimer1H;
		TMR1L				= DureeTimer1L;				// Prechargement pour obtenir les 10 ms
		ADCON0bits.GO		= 1;						// Declenchement de la conversion AN
		PIR1bits.TMR1IF 	= 0;
	}
}
//*************************************************************************************************************








