//*****************************************************************************************
// Commande du Variateur de Vitesse
//*****************************************************************************************
	#define Main_H
//*****************************************************************************************



//*****************************************************************************************
// Declaration des Entetes et variables
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************




//*****************************************************************************************
// Mise  jour des bits de configuration du PIC 18F1320
//*****************************************************************************************
#pragma config OSC 		= HSPLL			// Utilisation de la PLL pour l'horloge
#pragma config IESO 	= OFF			// Valide horloge interne au demarage jusqu'a HS valide
#pragma config FSCM 	= OFF			// sauvegarde en cas de defaillance de l'horloge
#pragma config PWRT 	= ON			// Timer de mise en route
#pragma config BOR 		= ON			// dtection d'une chute de tension
#pragma config BORV 	= 27			// dtection d'une chute de tension en dessous de 2,7 V
#pragma config WDT 		= OFF			// pas de chien de garde
#pragma config WDTPS 	= 32768			// POSTCALLER
#pragma config MCLRE 	= ON			// Valide MCLR
#pragma config WRTD 	= OFF			// Protection ecriture EEPROM
#pragma config LVP 		= OFF
#pragma config DEBUG 	= OFF
#pragma config STVR 	= OFF
//*****************************************************************************************






//*****************************************************************************************
// Programme Principal
//*****************************************************************************************
void main(void)
{
	static unsigned char i;

	InitPwm();
	InitPort();
	InitAdc();
	RS232Init();
	InitAcquisitionPpm();
	TestConv = 0;
	
	// Autorisations des interruptions
	INTCONbits.GIE 		= 1;			// Autorisation interruptions globales
	INTCONbits.PEIE 	= 1;			// Autorisation interruptions des periphriques
	RCONbits.IPEN 		= 1;			// Valide les niveaux d'interruption
	
	while(1)
	{
		for(i=1; i<=12; i++)
		{
			TXREG = OctetAEmettre[i];		//InputBuffer[0];
			PIR1bits.TXIF = 1;
			while(PIR1bits.TXIF == 0)
			{
				TestePwm();				// pour lancer la conversion Analogique - Numerique
			}
		}
	}
}
//*****************************************************************************************






