//*****************************************************************************************
// Declaration des Entetes et variables
//*****************************************************************************************
	#include	"../h/p18f1320.h"
	#include	"../h/Entete.h"
	#include	"../h/Var.h"
//*****************************************************************************************



//*****************************************************************************************
// Dfinition des constantes et Attribution de noms aux signaux
//*****************************************************************************************

	// Dure pour lancer la conversion AN : 10 ms sur le Timer 1 en interruption
	#define 	DureeTimer1H	0x3C	//0xec
	#define 	DureeTimer1L	0xB0	//0x78
	
	// Bit pour la mesure du courant dans le moteur
	#define 	VoieImot		0
	#define 	Imot			PORTAbits.RA0
	#define 	SensImot		TRISAbits.TRISA0
	#define 	TypeImot		ADCON1bits.PCFG0
	#define 	OffsetCourant	512					// Courant nul pour 2,5 V sur capteur effet hall
	
	// Bit pour la mesure de la tension de la batterie 1
	#define 	VoieVbat1		1
	#define 	Vbat1			PORTAbits.RA1
	#define 	SensVbat1		TRISAbits.TRISA1
	#define 	TypeVbat1		ADCON1bits.PCFG1
	
	// Bit pour la mesure de temperature des transistors MOS1
	#define 	VoieTempMos1	2
	#define 	TempMos1		PORTAbits.RA2
	#define 	SensTempMos1	TRISAbits.TRISA2
	#define 	TypeTempMos1	ADCON1bits.PCFG2

	// Bit pour la mesure de temperature des transistors MOS2
	#define 	VoieTempMos2	3
	#define 	TempMos2		PORTAbits.RA3
	#define 	SensTempMos2	TRISAbits.TRISA3
	#define 	TypeTempMos2	ADCON1bits.PCFG3


	// Bit pour la led Rouge
	#define 	LedRouge		LATBbits.LATB5
	#define 	SensLedRouge	TRISBbits.TRISB5


	// Bit du signal PPM
	#define 	PPM				LATBbits.LATB0
	#define 	SensPPM			TRISBbits.TRISB0
	#define 	TypePPM			ADCON1bits.PCFG4


	// Bit P1A
	#define 	P1A				LATBbits.LATB3
	#define 	SensP1A			TRISBbits.TRISB3

	// Bit P1B
	#define 	P1B				LATBbits.LATB2
	#define 	SensP1B			TRISBbits.TRISB2

	// Bit P1C
	#define 	P1C				LATBbits.LATB6
	#define 	SensP1C			TRISBbits.TRISB6

	// Bit P1D
	#define 	P1D				LATBbits.LATB7
	#define 	SensP1D			TRISBbits.TRISB7


	// Bit de Transmission Tx
	#define 	Tx				LATBbits.LATB1
	#define 	SensTx			TRISBbits.TRISB1
	#define 	TypeTx			ADCON1bits.PCFG5

	// Bit de Reception Rx
	#define 	Rx				LATBbits.LATB4
	#define 	SensRx			TRISBbits.TRISB4
	#define 	TypeRx			ADCON1bits.PCFG6


	// Definition des temps limites pour le signal PPM
	#define 	TempsVitInf			10000			// 10000 * 100 ns = 1 ms
	#define 	TempsVitSup			20000			// 20000 * 100 ns = 2 ms
	#define 	TempsVitNulle		15000			// 15000 * 100 ns = 1,5 ms
	#define 	TempsImpul300us		3000			// 3000 * 100 ns = 300 s
	#define 	TempsVitHyst		100				// 100 * 100 ns = 10 s
	
	// Limitation de la Vitesse de la voiture
	#define		CoefReducVitesse	4
	
//*****************************************************************************************
