//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//radio ADC
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************









//**********************************************************************************
// Initialisation du convertisseur analogique numerique
//**********************************************************************************
void RadioInitAdc(void)
{
	// Reglage de la dure de conversion d'un bit : il faut Tad > 1,6 s
	ADCON2bits.ADCS2 	= 1;		// Horloge pour la conversion : Fosc / 64
	ADCON2bits.ADCS1 	= 1;		// On obtient ici : Tad = 1,6 s
	ADCON2bits.ADCS0 	= 0;		// Soit un temps de conversion de 12 Tad env 20 s
	
	ADCON2bits.ACQT2 	= 1;		// Temps d'acquisition : 20 Tad
	ADCON2bits.ACQT1 	= 1;		// 
	ADCON2bits.ACQT0 	= 1;		// 

	ADCON2bits.ADFM 	= 1;		// Justification  droite du resultat
	
	ADCON0bits.ADON 	= 1;		// Mise en route du convertisseur
	
	ADCON1bits.PCFG3 	= 1;		// AN0, AN1 et AN2 en analogique 
	ADCON1bits.PCFG2 	= 1;		// RA0, RA1 et RA2
	ADCON1bits.PCFG1 	= 0;		// et tous les autres en numerique
	ADCON1bits.PCFG0 	= 0;
	
	ADCON1bits.VCFG1 	= 0;		// Vref- = GND
	ADCON1bits.VCFG0 	= 0;		// Vref+ = VDD

	IPR1bits.ADIP 		= 0;		// Interrupt non prioritaire
	PIR1bits.ADIF 		= 0;		// initialisation pour conversion
	PIE1bits.ADIE 		= 0;		// Interdiction Interruption 
}
//**********************************************************************************





//**********************************************************************************
// 						Selection du bit de conversion
// 			AN7		AN6		AN5		AN4		AN3		AN2		AN1		AN0
//  Voie = 	 7		 6		 5		 4		 3		 2		 1		 0
//**********************************************************************************
void RadioSelectionVoieAdc(unsigned char Voie)
{
	ADCON0bits.CHS2 = 0;
	ADCON0bits.CHS1 = 0;
	ADCON0bits.CHS0 = 0;
	
	if((Voie & 0x01) == 0x01)
	{
		ADCON0bits.CHS0 = 1;
	}
	
	if((Voie & 0x02) == 0x02)
	{
		ADCON0bits.CHS1 = 1;
	}
	
	if((Voie & 0x03) == 0x03)
	{
		ADCON0bits.CHS2 = 1;
	}
}
//**********************************************************************************








//**********************************************************************************
// Lecture de la valeur du convertisseur
//**********************************************************************************
unsigned int RadioConvAdc(unsigned char NumeroVoie)
{
	static unsigned int Test, Resul;
	
	RadioSelectionVoieAdc(NumeroVoie);
	
	Test = 25;
	while(Test != 0)				// Attente du temps acquisition
	{								// pour stabiliser le signal
		Test = Test - 1;
	}
	
	PIR1bits.ADIF = 0;				// Initialisation avant de convertir	
	ADCON0bits.GO = 1;				// Lance la conversion

	Test = 255;
	while(Test != 0)				// Attente fin de conversion
	{
		Test = Test - 1;
		if(PIR1bits.ADIF == 1)	Test = 0;
	}
	
	Resul = ADRESH;
	Resul = Resul << 8;
	Resul = Resul + ADRESL;				// Resultat sur 10 bits de la conversion AN
	
	return(Resul);
}
//**********************************************************************************





