//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
/radio direction
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************






//**********************************************************************************
// Initialisation pour l'acquisition de la position de la manette de Direction
//**********************************************************************************
void RadioInitAcquisitionDirection(void)
{
	static unsigned char Tampon;
	
	Tampon = RadioLitEeprom(0x0E);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		DirectionDroiteMini = DirectionDroiteMin;
	}
	else
	{
		DirectionDroiteMini = Tampon;
		DirectionDroiteMini = DirectionDroiteMini << 8;
		Tampon = RadioLitEeprom(0x0F);
		DirectionDroiteMini = DirectionDroiteMini + Tampon;
	}

	Tampon = RadioLitEeprom(0x10);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		DirectionDroiteMaxi = DirectionDroiteMax;
	}
	else
	{
		DirectionDroiteMaxi = Tampon;
		DirectionDroiteMaxi = DirectionDroiteMaxi << 8;
		Tampon = RadioLitEeprom(0x11);
		DirectionDroiteMaxi = DirectionDroiteMaxi + Tampon;
	}


	Tampon = RadioLitEeprom(0x12);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		DirectionGaucheMini = DirectionGaucheMin;
	}
	else
	{
		DirectionGaucheMini = Tampon;
		DirectionGaucheMini = DirectionGaucheMini << 8;
		Tampon = RadioLitEeprom(0x13);
		DirectionGaucheMini = DirectionGaucheMini + Tampon;
	}

	Tampon = RadioLitEeprom(0x14);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		DirectionGaucheMaxi = DirectionGaucheMax;
	}
	else
	{
		DirectionGaucheMaxi = Tampon;
		DirectionGaucheMaxi = DirectionGaucheMaxi << 8;
		Tampon = RadioLitEeprom(0x15);
		DirectionGaucheMaxi = DirectionGaucheMaxi + Tampon;
	}
	InversionDirection = 0;					// Manette de direction configure dans le bon sens
	SelectHystDirection = 0;				// Pour affichage hysteresis Direction
}
//**********************************************************************************



//**********************************************************************************
// Acquisition de la position de la manette de Direction
//**********************************************************************************
void RadioAcquisitionDirection(void)
{
	static unsigned int Dir;
	static unsigned long Numerateur, Denominateur;
	unsigned char Test;
	
	DirectionVoiture = RadioConvAdc(VoieDirection);	// Voir fichier RadioAdc.c
	
	if(DirectionVoiture > DirectionDroiteMini)		// Direction  Droite
	{
		Numerateur = DirectionVoiture - DirectionDroiteMini;
		Numerateur = Numerateur * CsteDureeBase0ms5;
		Denominateur = DirectionDroiteMaxi - DirectionDroiteMini;
		SequencePpm[NumImpulsionDirection] = Numerateur / Denominateur;
		
		if(InversionDirection == 0)
		{
			SequencePpm[NumImpulsionDirection] = CsteDureeBase1ms5 - SequencePpm[NumImpulsionDirection] - CsteDureeImpulsion;
		}
		else
		{
			SequencePpm[NumImpulsionDirection] = SequencePpm[NumImpulsionDirection] + CsteDureeBase1ms5 - CsteDureeImpulsion;
		}
	}
	else
	{
		if(DirectionVoiture < DirectionGaucheMini)	// Direction  Gauche
		{
			Numerateur = DirectionGaucheMini - DirectionVoiture;
			Numerateur = Numerateur * CsteDureeBase0ms5;
			Denominateur = DirectionGaucheMini - DirectionGaucheMaxi;
			SequencePpm[NumImpulsionDirection] = Numerateur / Denominateur;
			
			if(InversionDirection == 0)
			{
				SequencePpm[NumImpulsionDirection] = SequencePpm[NumImpulsionDirection] + CsteDureeBase1ms5 - CsteDureeImpulsion;
			}
			else
			{
				SequencePpm[NumImpulsionDirection] = CsteDureeBase1ms5 - SequencePpm[NumImpulsionDirection] - CsteDureeImpulsion;
			}
		}
		else							// Position neutre des roues
		{
			SequencePpm[NumImpulsionDirection] = CsteDureeBase1ms5 - CsteDureeImpulsion;		// Dure de l'impulsion = 1,5 ms pour la Direction
		}
	}
}
//**********************************************************************************



