//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//radio eeprom
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************


//**********************************************************************************
// Donnes stockes en EEPROM
//**********************************************************************************
/*	Adresse		Variable correspondante
	00 et 01		DureeSynchro
	02 et 03		DureeImpulsion
	04 et 05		DureeBase1ms
	06 et 07		VitesseAvantMini
	08 et 09 		VitesseAvantMaxi
	0A et 0B		VitesseArriereMini
	0C et 0D 		VitesseArriereMaxi
	0E et 0F		DirectionDroiteMini
	10 et 11 		DirectionDroiteMaxi
	12 et 13		DirectionGaucheMini
	14 et 15 		DirectionGaucheMaxi
*/
//**********************************************************************************






//**********************************************************************************
// Ecriture en EEPROM
//**********************************************************************************
void RadioEcritEeprom(unsigned char AdrEeprom, unsigned char DataEeprom)
{
	EEADR 				= AdrEeprom;
	EEDATA 				= DataEeprom;
	
	EECON1bits.EEPGD 	= 0;		// Pointe sur la mmoire Donne
	EECON1bits.CFGS 	= 0;		// Accede  la mmoire EEPROM
	EECON1bits.WREN 	= 1;		// Valide l'criture en EEPROM
	
	INTCONbits.GIE 		= 0;		// Interdit toutes les interruptions
	EECON2 				= 0x55;
	EECON2 				= 0xAA;
	
	EECON1bits.WR 		= 1;		// Debut de l'ecriture
	INTCONbits.GIE 		= 1;		// Autorise toutes les interruptions

	while(PIR2bits.EEIF == 0);
	EECON1bits.WREN 	= 0;		// Interdit l'criture en EEPROM
	PIR2bits.EEIF 		= 0;
	
	return;
}
//**********************************************************************************





//**********************************************************************************
// Lecture de la EEPROM
//**********************************************************************************
unsigned char RadioLitEeprom(unsigned char AdrEeprom)
{
	PIR2bits.EEIF 		= 0;			// Init pour la prochaine ecriture en EEPROM
	
	EEADR 				= AdrEeprom;
	
	EECON1bits.EEPGD 	= 0;			// Pointe sur la mmoire Donne
	EECON1bits.CFGS 	= 0;			// Accede  la mmoire EEPROM
	EECON1bits.RD 		= 1;			// Debut de l'ecriture
	
	return(EEDATA);
}
//**********************************************************************************








