//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//radio gnrateur PPM
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************


//**********************************************************************************
// Elaboration du signal PPM
//**********************************************************************************
//
// Toutes les variables sont definis dans le fichier RadioMain.h
// pour generer ce signal on utilise le Module de Comparaison 1 avec le Timer 1
// Modules CCP1CON et TIMER1
//
//**********************************************************************************







//**********************************************************************************
// Initilisation des variables pour gnrer le Signal PPM
//**********************************************************************************
void RadioInitVariablesPpm(void)
{
	static unsigned char Tampon;
	
	DureeSyncro 	= CsteDureeSyncro;	// Initialisation de la variable DureeSynchro

	DureeImpulsion 	= CsteDureeImpulsion;	// Initialisation de la variable DureeImpulsion

	DureeBase1ms 	= CsteDureeBase1ms;	// Initialisation de la variable DureeBase1ms
	
	NbSequence 		= (NbMaxiVoie << 1) + 2;	// Nombre de sequence pour le signal PPM
	
	AutorisationConversion = 0;					// Aucune conversion autorise
}
//**********************************************************************************





//**********************************************************************************
// Initilisation des valeurs pour le sequencement du signal PPM
//**********************************************************************************
void RadioInitSequencePpm(void)
{
	SequencePpm[1]		= DureeImpulsion;
	SequencePpm[2]		= DureeBase1ms;		// Voie 1 : Vitesse
	SequencePpm[3]		= DureeImpulsion;
	SequencePpm[4]		= DureeBase1ms;		// Voie 2 : Direction
	SequencePpm[5]		= DureeImpulsion;
	SequencePpm[6]		= DureeBase1ms;		// Voie 3 : Changement Boite Vitesse
	SequencePpm[7]		= DureeImpulsion;
	SequencePpm[8]		= DureeBase1ms;		// Accessoire 1
	SequencePpm[9]		= DureeImpulsion;
	SequencePpm[10]		= DureeBase1ms;		// Accessoire 2
	SequencePpm[11]		= DureeImpulsion;
	SequencePpm[12]		= DureeBase1ms;		// Accessoire 3
	SequencePpm[13]		= DureeImpulsion;
	SequencePpm[14]		= DureeSyncro;		
	NumeroSequencePpm	= 1;				// Initialisation a la 1ere valeur
}
//**********************************************************************************







//**********************************************************************************
// Initialisation du timer 1
//**********************************************************************************
void RadioInitTimer1(void)
{
	T1CONbits.RD16 		= 0;				// Mode opration sur 2 fois 8 bits
	
	T1CONbits.T1OSCEN 	= 0;				// Oscillateur externe
	
	T1CONbits.TMR1CS 	= 0;				// Horloge interne selectionne Fosc/4
	
	T1CONbits.T1CKPS1 	= 0;				// 
	T1CONbits.T1CKPS0 	= 0;				// Prdivision par 1

	T1CONbits.TMR1ON 	= 1;				// Mise ne route du Timer 1
	
	PIR1bits.TMR1IF 	= 0;				// Init du bit de depassement du Timer 1
	IPR1bits.TMR1IP 	= 0;				// Interrupt non prioritaire
	PIE1bits.TMR1IE 	= 0;				// Interdiction de l'interruption du Timer 1
	
}
//**********************************************************************************





//**********************************************************************************
// Initialisation du module de comparaison CCP1 et Timer1
//**********************************************************************************
void RadioInitComparaison(void)
{
	SensBitEmissionPpm		= 0;					// Bit emission PPm configur en sortie
	//BitEmissionPpm2		= 1;
	BitEmissionPpm			= ImpulPpmNegative;		// Initialisation  l'tat haut
	CompteNbDureeSynchro 	= 0;
	
	RadioInitTimer1();								// initilisation du Timer 1
	
	T3CONbits.T3CCP2 		= 0;					// 
	T3CONbits.T3CCP1 		= 1;					// Timer 1 avec CCP1 et Timer 3 avec CCP2
		
	CCP1CON 				= 0x0b;					// Mode special evenement
	
	IPR1bits.CCP1IP 		= 1;
	PIR1bits.CCP1IF 		= 0;
	PIE1bits.CCP1IE 		= 1;
}
//**********************************************************************************






//**********************************************************************************
// Initilisation de la nouvelle valeur pour faire bascule la sortie BitEmissionPpm
//**********************************************************************************
void RadioChangePpm(void)
{
	static unsigned char 	i, j;
	static unsigned int 	Tmp;
	static unsigned long 	Tempo;
	
	switch(NumeroSequencePpm)
	{
		case NbSequenceMax:				// 8 pour 3 voies
		{
			BitEmissionPpm		= !BitEmissionPpm;
			
			Tempo = 0;
			for(i=1; i<NbSequence; i++)
			{
				Tempo = Tempo + SequencePpm[i];
			}
			Tempo = Tempo >> 2;
			SequencePpm[NbSequenceMax] = CsteDureeSyncro - Tempo;
			//SequencePpm[NbSequence] = CsteDureeSyncro - Tempo;

			T1CONbits.T1CKPS1 	= 1;				// 
			T1CONbits.T1CKPS0 	= 0;				// Prdivision par 4
			
			Tmp 	= SequencePpm[NumeroSequencePpm] >> 8;
			CCPR1H 	= Tmp  & 0x00FF;
			CCPR1L	= SequencePpm[NumeroSequencePpm] & 0x00FF;
			
			RadioChangeImpulPpmPositive();
			
			RadioAcquisitionVitesse();
			RadioAcquisitionDirection();
			RadioAcquisitionBatRadio();
			
			NumeroSequencePpm = 1;
			AutorisationConversion = 1;
			break;
		}
	
		default:
		{
			BitEmissionPpm		= !BitEmissionPpm;
			T1CONbits.T1CKPS1 	= 0;				// 
			T1CONbits.T1CKPS0 	= 0;				// Prdivision par 1
			Tmp 	= SequencePpm[NumeroSequencePpm] >> 8;
			CCPR1H 	= Tmp  & 0x00FF;
			CCPR1L	= SequencePpm[NumeroSequencePpm] & 0x00FF;		
			NumeroSequencePpm = NumeroSequencePpm + 1;
			if(NumeroSequencePpm > NbSequence)
			{
				NumeroSequencePpm = 1;
			}
			break;
		}
	}
}
//**********************************************************************************



//**********************************************************************************
// Initilisation Generale du Signal PPM
//**********************************************************************************
void RadioInitGenerateurPpm(void)
{
	ImpulPpmNegative	= CsteImpulsionNegative;
	RadioInitVariablesPpm();
	RadioInitSequencePpm();
	RadioInitComparaison();
}
//**********************************************************************************





//**********************************************************************************
// Initilisation Generale du Signal PPM
//**********************************************************************************
void RadioChangeImpulPpmPositive(void)
{
	static unsigned char t;
	
	if(BitEmissionPpm != ImpulPpmNegative)
	{
		BitEmissionPpm		= ImpulPpmNegative;		// Initialisation  l'tat haut
	}
}
//**********************************************************************************





