//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//radio interrupt
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************



//**********************************************************************************
//**********************************************************************************




//**********************************************************************************
// Dclaration d'instruction en assembleur dans le C
//**********************************************************************************
#pragma code int_prioritaire=0x0008
void interrupt_at_high_vector(void)
{
	_asm GOTO Int_niveau_fort _endasm
}

#pragma code int_non_prioritaire=0x0018
void interrupt_at_low_vector(void)
{
	_asm GOTO Int_niv_faible _endasm
}
/**********************************************************************************/

#pragma code 									// Retour au code programme en C
#pragma interrupt 		Int_niveau_fort		nosave=section(".tmpdata"),section("MATH_DATA"),TABLAT,PROD,TBLPTR
#pragma interruptlow 	Int_niv_faible		nosave=section(".tmpdata"),section("MATH_DATA"),TABLAT,PROD,TBLPTR



//**********************************************************************************
// Interruption de niveau fort
//**********************************************************************************
void Int_niveau_fort(void)
{
	if(PIR1bits.CCP1IF == 1)
	{
		TMR1H						= 0;
		TMR1L						= 0;
		
		RadioChangePpm();

		PIR1bits.CCP1IF 			= 0;
	}



}
//**********************************************************************************




//**********************************************************************************
// Interruption de niveau faible
//**********************************************************************************
void Int_niv_faible(void)
{
	static unsigned char t;
	
	if(INTCONbits.TMR0IF == 1)
	{
		TMR0H = 0x02;
		TMR0L = 0x2A;							// Pour obtenir 15 ms
		RadioAcquisitionVitesse();
		RadioAcquisitionDirection();
		INTCONbits.TMR0IF = 0;
	}
	
	if(PIR1bits.RCIF == 1)						// Reception RS232
	{
		t = RCSTA;
		CaracRecu = RCREG;
		RCSTAbits.CREN 		= 0;				// Arrete la reception
		
		RadioTelemetrieDecode();
		
		/*
		if(CaracRecu == 0x41)						// Debut de trame Code Ascii : A
		{
			CptReceptRs232 		= 0;
			CaracRecuRs232[CptReceptRs232] = CaracRecu;
			CptReceptRs232++;
			ReceptionComplete	= 0;
		}
		else
		{
			if(CaracRecu == 0x5a)					// Fin de trame Code Ascii : Z
			{
				CaracRecuRs232[CptReceptRs232] = CaracRecu;
				ReceptionComplete	= 1;
			}
			else
			{
				if((CaracRecu > 0x2f) & (CaracRecu < 0x40))
				{
					CaracRecuRs232[CptReceptRs232] = CaracRecu;
					CptReceptRs232++;
				}
				else							// Erreur de reception
				{
					
				}
			}
		}
		
		if(CptReceptRs232 > 20)
		{
			CptReceptRs232 		= 0;
			ReceptionComplete	= 0;
		}
		*/
		PIR1bits.RCIF 		= 0;
		RCSTAbits.CREN 		= 1;
	}
}
//**********************************************************************************

