//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//Radio LCD
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************











//**********************************************************************************
// Temporisation de tmp ms
//**********************************************************************************
void RadioLcdTempo1ms(unsigned char tmp)
{
	unsigned int i, j;
	for(j=1; j<=tmp; j++)
	{
		for(i=1; i<700; i++);
	}
}
//**********************************************************************************



//**********************************************************************************
// Lecture du bit BF de l'afficheur LCD
//**********************************************************************************
unsigned char RadioLcdReadBf(void)
{
	unsigned char i;
	static unsigned char valeur;
	
	SensE = 0;
	SensRS = 0;
	SensRW = 0;
	SensDB4 = 1;
	SensDB5 = 1;
	SensDB6 = 1;
	SensDB7 = 1;
	
	RS = 0;
	RW = 1;
	E = 1;
	
	for(i=1; i<5; i++);
	
	valeur = 0;
	if((LectAdr & BF) == BF)	valeur = 255;
	
	E = 0;
	for(i=1; i<5; i++);
	E = 1;
	for(i=1; i<5; i++);
	E = 0;
	
	return(valeur);
}
//**********************************************************************************




//**********************************************************************************
// Ecriture dans la DDRAM ou la CGRAM
// Data = 0  0  RS  RW   DB7  DB6  DB5  DB4
//**********************************************************************************
void RadioLcdEcritDigit(unsigned char Data)
{
	unsigned char i;
	
	SensE = 0;
	SensRS = 0;
	SensRW = 0;
	SensDB4 = 0;
	SensDB5 = 0;
	SensDB6 = 0;
	SensDB7 = 0;
	
	E = 0;
	
	RS = 0;
	RW = 0;
	if((Data & 0x20) == 0x20)		RS = 1;		// Test du bit RS
	if((Data & 0x10) == 0x10)		RW = 1;		// Test du bit RW
	
	E = 1;
	
	DB7 = 0;
	DB6 = 0;
	DB5 = 0;
	DB4 = 0;
	if((Data & 0x01) == 0x01)		DB4 = 1;	// Test du bit DB4
	if((Data & 0x02) == 0x02)		DB5 = 1;	// Test du bit DB5
	if((Data & 0x04) == 0x04)		DB6 = 1;	// Test du bit DB6
	if((Data & 0x08) == 0x08)		DB7 = 1;	// Test du bit DB7

	for(i=1; i<30; i++);
	E = 0;
	for(i=1; i<30; i++);
}
//**********************************************************************************





//**********************************************************************************
// Ecrit 2 Digit sur l'afficheur
// CtrlLCD : 
// DataLCD :
//**********************************************************************************
void RadioLcdEcritOctet(unsigned char CtrlLCD,unsigned char DataLCD)
{
	static unsigned char Ctrl, Data;
	
	Ctrl = (CtrlLCD << 4);
	
	Data = (DataLCD & 0xF0);
	Data = (Data >> 4);
	Data = (Data | Ctrl);
	RadioLcdEcritDigit(Data);			// Ecriture poid fort

	Data = (DataLCD & 0x0F);
	Data = (Data | Ctrl);
	RadioLcdEcritDigit(Data);			// Ecriture poid faible
}
//**********************************************************************************





//**********************************************************************************
// Ecrit un caracter sur l'afficheur LCD
//**********************************************************************************
void RadioLcdEcritCarac(unsigned char Carac)
{
	RadioLcdEcritOctet(0x02, Carac);
}
//**********************************************************************************







//**********************************************************************************
// Ecrit un Texte sur l'afficheur LCD
//**********************************************************************************
void RadioLcdEcritTexte(unsigned char AdrDepartLcd, char *TextLcd)
{
	static unsigned char Carac;
	
	RadioLcdChangeAdrDdram(AdrDepartLcd);
	Carac = *TextLcd;
	while(*TextLcd != '\0')
	{
		Carac = *TextLcd;
		RadioLcdEcritCarac(Carac);
		TextLcd++;
	}
}
//**********************************************************************************







//**********************************************************************************
// Initialisation de la position du curseur de l'afficheur LCD
//**********************************************************************************
void RadioLcdHome(void)
{
	RadioLcdEcritOctet(0x00, 0x02);
	RadioLcdTempo1ms(10);
}
//**********************************************************************************



//**********************************************************************************
// Effacement de l'afficheur LCD
//**********************************************************************************
void RadioLcdEfface(void)
{
	RadioLcdEcritOctet(0x00, 0x01);
	RadioLcdTempo1ms(20);
}
//**********************************************************************************



//**********************************************************************************
// Change l'adresse de la DDRAM de l'afficheur LCD
//**********************************************************************************
void RadioLcdChangeAdrDdram(unsigned char Carac)
{
	Carac = Carac | 0x80;
	RadioLcdEcritOctet(0x00, Carac);
}
//**********************************************************************************






//**********************************************************************************
// Ecrire en CGRAM sur l'afficheur LCD
//**********************************************************************************
void RadioLcdEcritCgram(unsigned char AdrCgram, unsigned char DataCgram)
{
	unsigned char i;
	
	i = (AdrCgram & 0x3F);
	i = (i | 0x40);
	RadioLcdEcritOctet(0x00, i);				// Ecriture de l'adresse dans la CGRAM
	while(RadioLcdReadBf() == 255);			// Attente de liberation du LCD
	RadioLcdEcritOctet(0x02, DataCgram);		// Ecriture de la donne dans la CGRAM
	while(RadioLcdReadBf() == 255);			// Attente de liberation du LCD
}
//**********************************************************************************






//**********************************************************************************
// Ecrit un caractere sur l'afficheur LCD
//**********************************************************************************
void RadioLcdModeSet(unsigned char Carac)
{
	RadioLcdEcritOctet(0x00, Carac);
}
//**********************************************************************************



//**********************************************************************************
// Met en route l'afficheur LCD
//**********************************************************************************
void RadioLcdDisplay(unsigned char Carac)
{
	RadioLcdEcritOctet(0x00, Carac);
}
//**********************************************************************************





//**********************************************************************************
// Initialisation de l'afficheur LCD
//**********************************************************************************
void RadioLcdInit(void)
{
	unsigned char DataLcd;		// DataLcd = 0  0  RS  RW   DB7  DB6  DB5  DB4
	
	SensE = 0;
	SensRW = 0;
	SensRS = 0;
	
	SensDB4 = 0;
	SensDB5 = 0;
	SensDB6 = 0;
	SensDB7 = 0;
	
	// Etape 1
	RadioLcdTempo1ms(50);				// Temporisation de 15 ms
	
	// Etape 2
	DataLcd = 0x03;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 3
	RadioLcdTempo1ms(20);				// Temporisation de 5 ms

	// Etape 4
	DataLcd = 0x03;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 5
	RadioLcdTempo1ms(5);				// Temporisation de 1 ms
	
	// Etape 6
	DataLcd = 0x03;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 7					BF peut etre utilis  partir d'ici
	DataLcd = 0x02;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 8					Function Set 1/2
	DataLcd = 0x02;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 9					Function Set 2/2
	DataLcd = 0x08;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 10					Display Off 1/2
	DataLcd = 0x00;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 11					Display Off 2/2
	DataLcd = 0x08;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 12					Display On 1/2
	DataLcd = 0x00;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 13					Display On 2/2
	DataLcd = 0x0C;
	RadioLcdEcritDigit(DataLcd);
	
	while(RadioLcdReadBf() == 255);
		
	// Etape 14					Entry Mode Set 1/2
	DataLcd = 0x00;
	RadioLcdEcritDigit(DataLcd);
	
	// Etape 15					Entry Mode Set 2/2
	DataLcd = 0x06;
	RadioLcdEcritDigit(DataLcd);
	while(RadioLcdReadBf() == 255);
	
	RadioLcdEfface();
	RadioLcdTempo1ms(40);
}
//**********************************************************************************







//**********************************************************************************
// Affichage sur l'cran LCD des 2 digit de la valeur Data  l'adresse AdrLCD
// en tenant compte du signe (bit de poid fort)
//**********************************************************************************
void RadioLcdAfficheHexa(char AdrLCD, unsigned char Data)
{
	static unsigned char Signe, Carac1, Carac2, Carac;
	
	RadioLcdChangeAdrDdram(AdrLCD);
	
	Carac = Data;
	
	Carac1 = ((Carac & 0xF0) >> 4);
	if(Carac1 > 0x09)
	{
		Carac1 = Carac1 + 0x07;
	}
	
	Carac2 = Carac & 0x0F;
	if(Carac2 > 0x09)
	{
		Carac2 = Carac2 + 0x07;
	}
	
	RadioLcdEcritCarac(Carac1 + 0x30);
	RadioLcdEcritCarac(Carac2 + 0x30);
}
//**********************************************************************************






//**********************************************************************************
// Affichage sur l'cran LCD des 2 digit de la valeur Data  l'adresse AdrLCD
// en tenant compte du signe (bit de poid fort)
//**********************************************************************************
void RadioLcdAfficheHexaSigned(char AdrLCD, unsigned char Data)
{
	static unsigned char Signe, Carac1, Carac2, Carac;
	
	RadioLcdChangeAdrDdram(AdrLCD);
	
	if(Data < 0x80)				// Nombre positif
	{
		Signe = ' ';
		Carac = Data;
	}
	else						// Nombre negatif
	{
		Signe = '-';
		Carac = Data - 0x80;
	}
	
	Carac1 = ((Carac & 0xF0) >> 4);
	if(Carac1 > 0x09)
	{
		Carac1 = Carac1 + 0x07;
	}
	
	Carac2 = Carac & 0x0F;
	if(Carac2 > 0x09)
	{
		Carac2 = Carac2 + 0x07;
	}
	
	RadioLcdEcritCarac(Signe);
	RadioLcdEcritCarac(Carac1 + 0x30);
	RadioLcdEcritCarac(Carac2 + 0x30);
}
//**********************************************************************************







//**********************************************************************************
// Conversion de l'hexa en decimal
//**********************************************************************************
void RadioLcdConversionHexaDecimal(unsigned int HexaLCD)
{
	static unsigned int d, r, q;
	
	d = HexaLCD;
	
	q = d / 10;
	r = d - q * 10;
	LcdHexaDecimal[4] = r + 0x30;
	d = q;
	
	q = d / 10;
	r = d - q * 10;
	LcdHexaDecimal[3] = r + 0x30;
	d = q;
	
	q = d / 10;
	r = d - q * 10;
	LcdHexaDecimal[2] = r + 0x30;
	d = q;
	
	q = d / 10;
	r = d - q * 10;
	LcdHexaDecimal[1] = r + 0x30;
	
	LcdHexaDecimal[0] = q + 0x30;
}
//**********************************************************************************




//**********************************************************************************
// Affichage sur l'cran LCD des 2 digit de la valeur Data  l'adresse AdrLCD
// en tenant compte du signe (bit de poid fort)
//**********************************************************************************
void RadioLcdAfficheDecimal(char AdrLCD, unsigned int Data)
{
	static unsigned char Signe, Carac1, Carac2, Carac;
	static unsigned char Aff[5];
	
	RadioLcdChangeAdrDdram(AdrLCD);
	
	RadioLcdConversionHexaDecimal(Data);
	Aff[1]		= LcdHexaDecimal[1];
	Aff[2]		= LcdHexaDecimal[2];
	Aff[3]		= LcdHexaDecimal[3];
	Aff[4]		= LcdHexaDecimal[4];
	
	RadioLcdEcritCarac(Aff[1]);
	RadioLcdEcritCarac(Aff[2]);
	RadioLcdEcritCarac(Aff[3]);
	RadioLcdEcritCarac(Aff[4]);
}
//**********************************************************************************




//**********************************************************************************
// 
// 
//**********************************************************************************
void RadioLcdAfficheVolt(char AdrLCD, unsigned int Data)
{
	static unsigned char BatVolt[5];
	
	RadioLcdChangeAdrDdram(AdrLCD);
	
	RadioLcdConversionHexaDecimal(Data);
	BatVolt[1]	= LcdHexaDecimal[1];
	BatVolt[2]	= LcdHexaDecimal[2];
	BatVolt[3]	= LcdHexaDecimal[3];
	BatVolt[4]	= LcdHexaDecimal[4];
	
	RadioLcdEcritCarac(BatVolt[1]);
	RadioLcdEcritCarac(BatVolt[2]);
	RadioLcdEcritCarac('.');
	RadioLcdEcritCarac(BatVolt[3]);
	RadioLcdEcritCarac(BatVolt[4]);
}
//**********************************************************************************
