//*****************************************************************************************
// Declaration des Entetes et variables
//Radio - Main
//contrat 2
//*****************************************************************************************
	#include	"../Lkr/p18f2520.h"
	#include	"../Radio/RadioEntete.h"
	#include	"../Radio/RadioVar.h"
//*****************************************************************************************




//*******************************************************************************************
// Le signal PPM 
// Utilisation du Timer 1 et du Comparateur 1
//*******************************************************************************************
	#define NbMaxiVoie				6					// Nombre de voie du signal PPM
	#define NbSequenceMax			14					// = (NbMaxiVoie * 2) + 2

	// Generation des temps pour elaborer le signal PPM
	// utilisation quartz 10 MHz avec PLL Fcyc = 100 ns
	#define CsteDureeSyncro 		50414				// 50000 Dure de 20 ms 	= 4 * 50000 * 100 ns
	#define NbDureeSynchro			4					// 
	#define CsteDureeImpulsion 		3000				// Dure de 300 s 	= 3000 * 100 ns
	#define CsteDureeBase0ms5 		5000				// Dure de 0.5 ms 	= 5000 * 100 ns
	#define CsteDureeBase0ms7 		7000				// Dure de 0.7 ms 	= 7000 * 100 ns
	#define CsteDureeBase1ms 		10000				// Dure de 1 ms 	= 10000 * 100 ns
	#define CsteDureeBase1ms5 		15000				// Dure de 1.5 ms 	= 15000 * 100 ns


	// Bit utilis pour l'emission HF du signal PPM
	#define BitEmissionPpm 			LATCbits.LATC2		// Bit utilis pour l'emission
	#define BitEmissionPpm2			PORTCbits.RC2		// Bit utilis pour l'emission
	#define SensBitEmissionPpm 		TRISCbits.TRISC2	// Mettre le bit en sortie
	#define CsteImpulsionNegative	0					// 1 pour avoir une impulsion positive
//*******************************************************************************************
	
		

//*******************************************************************************************
// La mesure de la tension de la batterie
//*******************************************************************************************
	#define VoieVbat				2					// Indique la voie de conv de la tension Vbat
//*******************************************************************************************


		
//*******************************************************************************************
// La manette de Direction
//*******************************************************************************************
	#define VoieDirection			1					// Indique la voie de conv pour le potentiometre de direction
	#define NumImpulsionDirection	2					// Numero de l'impulsion sur le signal PPM
	#define DirectionDroiteMin		623					// Direction  droite Mini par defaut
	#define DirectionDroiteMax		1023				// Direction  droite Maxi par defaut
	#define DirectionGaucheMin		400					// Direction  gauche Mini par defaut
	#define DirectionGaucheMax		0					// Direction  gauche Maxi par defaut
//*******************************************************************************************


		
//*******************************************************************************************
// La manette de Vitesse
//*******************************************************************************************
	#define VoieVitesse				0					// Indique la voie de conv pour le potentiometre de Vitesse
	#define NumImpulsionVitesse		4					// Numero de l'impulsion sur le signal PPM
	#define VitesseAvantMin			623					// Vitesse Avant Mini par defaut
	#define VitesseAvantMax			1023				// Vitesse Avant Maxi par defaut
	#define VitesseArriereMin		400					// Vitesse Arriere Mini par defaut
	#define VitesseArriereMax		0					// Vitesse Arriere Maxi par defaut
//*******************************************************************************************
	


//*******************************************************************************************
// La gestion de la bote de vitesse
//*******************************************************************************************
	#define CsteRapportBoite		10000				// Dure de 1 ms = 1 * 10000 * 100 ns
	#define NumImpulsionRapport		6					// Numero de l'impulsion sur le signal PPM
//*******************************************************************************************


		
//*******************************************************************************************
// La gestion des Accessoires
//*******************************************************************************************
	#define CsteAccessoire1			10000				// Dure de 1 ms = 1 * 10000 * 100 ns
	#define NumImpulsionAccess1		8					// Numero de l'impulsion sur le signal PPM

	#define CsteAccessoire2			10000				// Dure de 1 ms = 1 * 10000 * 100 ns
	#define NumImpulsionAccess2		10					// Numero de l'impulsion sur le signal PPM

	#define CsteAccessoire3			10000				// Dure de 1 ms = 1 * 10000 * 100 ns
	#define NumImpulsionAccess3		12					// Numero de l'impulsion sur le signal PPM
//*******************************************************************************************


		
//*******************************************************************************************
// La gestion des boutons poussoirs
//*******************************************************************************************
	// Bouton Mode
	#define BpMode 					PORTCbits.RC5		// Bit Bouton Poussoir
	#define SensBpMode 				TRISCbits.TRISC5	// Sens Bit Bouton Poussoir
	
	// Bouton Valider
	#define BpValider		 		PORTAbits.RA4		// Bit Bouton Poussoir
	#define SensBpvalider		 	TRISAbits.TRISA4	// Sens Bit Bouton Poussoir

	// Bouton Plus
	#define BpPlus 					PORTCbits.RC1		// Bit Bouton Poussoir
	#define SensBpPlus 				TRISCbits.TRISC1	// Sens Bit Bouton Poussoir

	// Bouton Moins
	#define BpMoins 				PORTCbits.RC0		// Bit Bouton Poussoir
	#define SensBpMoins 			TRISCbits.TRISC0	// Sens Bit Bouton Poussoir
		
		
	//#define LedBoutonPoussoir 		TRISBbits.TRISB3	// Led du bouton Poussoir
//*******************************************************************************************



//*******************************************************************************************
// Gestion du signal de reception pour la tlmtrie
//*******************************************************************************************
	// Definition des sens signaux pour Emission Reception RS232
	#define TxEn			LATCbits.LATC3			// Bit TxEn pour RS232
	#define Tx				LATCbits.LATC6
	#define SensTxEn		TRISCbits.TRISC3		// TxEn en sortie
	#define SensTx 			TRISCbits.TRISC6

	#define RxEn			LATCbits.LATC4			// Bit RxEn pour RS232
	#define Rx		 		LATCbits.LATC7
	#define SensRxEn		TRISCbits.TRISC4		// RxEn en sortie
	#define SensRx 			TRISCbits.TRISC7
//*******************************************************************************************



	
//*******************************************************************************************
// Gestion de l'afficheur LCD
//*******************************************************************************************
// Nombre de caracteres par ligne sur l'afficheur LCD
	#define NbCaracAffich 	21

// Definition des signaux pour l'afficheur LCD
	#define E 				LATAbits.LATA5
	#define RW 				LATBbits.LATB4
	#define RS 				LATBbits.LATB5

// Definition des sens signaux pour l'afficheur LCD
	#define SensE 			TRISAbits.TRISA5
	#define SensRW 			TRISBbits.TRISB4
	#define SensRS 			TRISBbits.TRISB5

// Pour le PIC 18F252
	#define DB4 			LATBbits.LATB0
	#define DB5 			LATBbits.LATB1
	#define DB6 			LATBbits.LATB2
	#define DB7 			LATBbits.LATB3

// Pour le PIC 18F252
	#define SensDB4 		TRISBbits.TRISB0
	#define SensDB5 		TRISBbits.TRISB1
	#define SensDB6 		TRISBbits.TRISB2
	#define SensDB7 		TRISBbits.TRISB3

	#define LectAdr 		PORTB				// Port ou se trouve les bits de donnes de l'afficheur
	#define BF 				0x08				// Position du BF dans LectAdr
//*******************************************************************************************



