//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//Radio RS232
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************




//**********************************************************************************
// Initialisation du module USART pour protocole RS232 en transmission
//**********************************************************************************
void RadioRS232InitTransmission(void)
{
	SensTxEn 		= 0;
	SensTx 			= 0;			// Config en mode sortie
	
	RCSTAbits.SPEN 	= 1;			// Validation du port srie
	
	TXSTAbits.TX9 	= 0;			// Mode 8 bits
	TXSTAbits.TXEN 	= 1;			// Validation de la Transmission
	
	PIE1bits.TXIE 	= 0;			// Interdiction interruption de la transmission
	IPR1bits.TXIP 	= 0;			// Interrupt prioritaire
	PIR1bits.TXIF 	= 0;			// Init du bit de registre de transmission plein
}
//**********************************************************************************





//**********************************************************************************
// Initialisation du module USART pour protocole RS232 en reception
//**********************************************************************************
void RadioRS232InitReception(void)
{
	SensRxEn 			= 0;
	SensRx 				= 1;			// Config en mode entree
	
	RadioRS232InitBaud();
	
	RCSTAbits.RX9 		= 0;			// Mode 8 bits
	RCSTAbits.CREN 		= 1;			// 
	
	RCSTAbits.SPEN 		= 1;			// Validation du port srie mode asynchrone
	BAUDCONbits.RCIDL	= 0;			// Active la ligne de reception
	BAUDCONbits.WUE		= 0;			// Active la ligne de reception
	
	IPR1bits.RCIP 		= 0;			// Interrupt Non Prioritaire
	PIR1bits.RCIF 		= 0;			// Init du bit de registre de recepetion plein
	PIE1bits.RCIE 		= 1;			// Autorisation interruption de la reception
}
//**********************************************************************************





//**********************************************************************************
// Initialisation de la vitesse de tramission du module USART pour protocole RS232
// Mode de calcul en asynchrone 16 bits : N = Fosc/(16 x Baud) - 1
// pour Baud = 9600 et Fosc = 40 MHz on a N = 259 = 0x0103
//**********************************************************************************
void RadioRS232InitBaud(void)
{
	TXSTAbits.SYNC 		= 0;			// Mode Asynchrone
	TXSTAbits.BRGH 		= 0;			// Faible Vitesse de transmission
	BAUDCONbits.BRG16	= 1;			// Mode 16 bits pour registre de Bauds
	SPBRGH 				= 0x04;			// 0x04 2400 bauds avec Fosc = 40 MHz - 259 = 0x0103
	SPBRG 				= 0x11;			// 0x11 2400 bauds avec Fosc = 40 MHz
}
//**********************************************************************************





//**********************************************************************************
// Configuration en mode Emission
//**********************************************************************************
void RadioRS232ConfigEmission(void)
{
	RxEn			= 1;
	TxEn			= 0;
}
//**********************************************************************************





//**********************************************************************************
// Configuration en mode Reception
//**********************************************************************************
void RadioRS232ConfigReception(void)
{
	TxEn			= 1;
	RxEn			= 0;
}
//**********************************************************************************




