//*****************************************************************************************
// Declaration des Entetes et variables
//Contrat 2
//radio vitesse
//*****************************************************************************************
	#include	"../Radio/RadioMain.h"
//*****************************************************************************************






//**********************************************************************************
// Initialisation pour l'acquisition de la position de la manette de vitesse
//**********************************************************************************
void RadioInitAcquisitionVitesse(void)
{
	static unsigned char Tampon;
	
	Tampon = RadioLitEeprom(0x06);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		VitesseAvantMini = VitesseAvantMin;
	}
	else
	{
		VitesseAvantMini = Tampon;
		VitesseAvantMini = VitesseAvantMini << 8;
		Tampon = RadioLitEeprom(0x07);
		VitesseAvantMini = VitesseAvantMini + Tampon;
	}

	Tampon = RadioLitEeprom(0x08);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		VitesseAvantMaxi = VitesseAvantMax;
	}
	else
	{
		VitesseAvantMaxi = Tampon;
		VitesseAvantMaxi = VitesseAvantMaxi << 8;
		Tampon = RadioLitEeprom(0x09);
		VitesseAvantMaxi = VitesseAvantMaxi + Tampon;
	}


	Tampon = RadioLitEeprom(0x0A);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		VitesseArriereMini = VitesseArriereMin;
	}
	else
	{
		VitesseArriereMini = Tampon;
		VitesseArriereMini = VitesseArriereMini << 8;
		Tampon = RadioLitEeprom(0x0B);
		VitesseArriereMini = VitesseArriereMini + Tampon;
	}

	Tampon = RadioLitEeprom(0x0C);
	if(Tampon == 0xFF)
	{
		// La EEPROM n'a pas t modifie
		VitesseArriereMaxi = VitesseArriereMax;
	}
	else
	{
		VitesseArriereMaxi = Tampon;
		VitesseArriereMaxi = VitesseArriereMaxi << 8;
		Tampon = RadioLitEeprom(0x0D);
		VitesseArriereMaxi = VitesseArriereMaxi + Tampon;
	}
	InversionVitesse 	= 0;					// Manette de vitesse configure dans le bon sens
	SelectHystVitesse 	= 0;					// Pour affichage hysteresis Vitesse
}
//**********************************************************************************



//**********************************************************************************
// Acquisition de la position de la manette de vitesse
//**********************************************************************************
void RadioAcquisitionVitesse(void)
{
	static unsigned int Vit;
	static unsigned long Numerateur, Denominateur;
	static unsigned int Test;
	
	VitesseVoiture = RadioConvAdc(VoieVitesse); 	// Voir fichier RadioAdc.c
	
	if(VitesseVoiture > VitesseAvantMini)		// Marche Avant
	{
		Numerateur = VitesseVoiture - VitesseAvantMini;
		Numerateur = Numerateur * CsteDureeBase0ms5;
		Denominateur = VitesseAvantMaxi - VitesseAvantMini;
		SequencePpm[NumImpulsionVitesse] = Numerateur / Denominateur;
		
		if(InversionVitesse == 0)
		{
			SequencePpm[NumImpulsionVitesse] = CsteDureeBase1ms5 - SequencePpm[NumImpulsionVitesse] - CsteDureeImpulsion;
		}
		else
		{
			SequencePpm[NumImpulsionVitesse] = SequencePpm[NumImpulsionVitesse] + CsteDureeBase1ms5 - CsteDureeImpulsion;
		}
	}
	else
	{
		if(VitesseVoiture < VitesseArriereMini)	// Marche arriere
		{
			Numerateur = VitesseArriereMini - VitesseVoiture;
			Numerateur = Numerateur * CsteDureeBase0ms5;
			Denominateur = VitesseArriereMini - VitesseArriereMaxi;
			SequencePpm[NumImpulsionVitesse] = Numerateur / Denominateur;
			
			if(InversionVitesse == 0)
			{
				SequencePpm[NumImpulsionVitesse] = SequencePpm[NumImpulsionVitesse] + CsteDureeBase1ms5 - CsteDureeImpulsion;
			}
			else
			{
				SequencePpm[NumImpulsionVitesse] = CsteDureeBase1ms5 - SequencePpm[NumImpulsionVitesse] - CsteDureeImpulsion;
			}
		}
		else							// Arret des moteurs
		{
			SequencePpm[NumImpulsionVitesse] = CsteDureeBase1ms5 - CsteDureeImpulsion;		// Dure de l'impulsion = 1,5 ms pour la vitesse
		}
	}
}
//**********************************************************************************



