//*****************************************************************************************
// Declaration des Entetes et variables
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************





//**********************************************************************************
// Initialisation du Timer 1
//**********************************************************************************
void InitTimer1(void)
{
	T1CONbits.RD16 = 0;			// Lecture et Ecriture en 2 registre de 8 bits
	
	T1CONbits.T1OSCEN = 0;		// Non utilisation d'horloge externe
	
	T1CONbits.TMR1CS = 0;		// Slection Horloge interne oscillateur
	
	T1CONbits.T1CKPS1 = 1;		// 
	T1CONbits.T1CKPS0 = 0;		// Predivision par 4

	T1CONbits.TMR1ON = 1;		// Mise ne route du Timer 1
	
	PIR1bits.TMR1IF = 0;		// Init du bit de depassement
	IPR1bits.TMR1IP = 0;		// Interrupt non prioritaire
	PIE1bits.TMR1IE = 0;		// Interdiction interruption du Timer 1
}
//**********************************************************************************



//**********************************************************************************
// Initialisation du Comparateur 1
// Obtenir le signal PPM
// Signal entre 1 et 2 ms toutes les 20 ms
//**********************************************************************************
void InitComparateur1(void)
{
	InitTimer1();
	
	T3CONbits.T3CCP2		= 0;						// CCP2 et Timer 3
	T3CONbits.T3CCP1		= 1;						// CCP1 et Tiemr 1
	
	CCP1CONbits.CCP1M3		= 1;
	CCP1CONbits.CCP1M2		= 0;
	CCP1CONbits.CCP1M1		= 1;
	CCP1CONbits.CCP1M0		= 1;						// Mode comparateur avec timer 1
	
	SensSignalPpm			= 0;
	SignalPpm				= 0;
	PeriodePpm				= 4500;						// Signal PPM de 1,5 ms : point mort
	PeriodeCompH			= PeriodePpm >> 8;
	PeriodeCompL			= PeriodePpm & 0x00FF;
	NumPeriodePpm			= 0;						// 1ere demi periode
	
	PIR1bits.CCP1IF			= 0;						// Init du bit de comparaison
	IPR1bits.CCP1IP			= 0;						// Interrupt non prioritaire
	PIE1bits.CCP1IE			= 1;						// Autorisation interruption
}	
//**********************************************************************************





