#define Main_H


//*****************************************************************************************
// Declaration des Entetes et variables
//*****************************************************************************************
	#include	"../h/Main.h"
//*****************************************************************************************




//***********************************************************************************
// Config des bits de configuration
#pragma config PLLDIV = 1
#pragma config CPUDIV = OSC1_PLL2
#pragma config USBDIV = 2
#pragma config FOSC = HSPLL_HS
#pragma config PWRT = ON					// Activation du Power On reset
#pragma config BOR = ON						// dtection d'une chute de tension
#pragma config BORV = 3						// dtection d'une chute de tension en dessous de 2,8 V
#pragma config WDT = OFF					// pas de chien de garde
#pragma config MCLRE = ON
#pragma config LPT1OSC = OFF
#pragma config PBADEN = OFF
#pragma config STVREN = OFF
#pragma config CCP2MX = ON					// Valide RC1 pour le PWM
#pragma config LVP = OFF					// inhibition de la programmation basse tension
#pragma config DEBUG = ON					// Sort du mode Debug
#pragma config XINST = OFF
#pragma config VREGEN = ON					// Valide l'alimentation du module USB
// Fin de config des bits de configuration
//***********************************************************************************






//**********************************************************************************************
// Initialisation gnrale
//**********************************************************************************************
void InitGeneral(void)
{
	mInitializeUSBDriver();         // See usbdrv.h
	RS232InitReception();			// Init de la liaison RS232
	InitComparateur1();
	
	// Autorisations des interruptions
	RCONbits.IPEN = 1;			// Valide les niveaux d'interruption
	INTCONbits.GIE = 1;			// Autorisation interruptions globales
	INTCONbits.PEIE = 1;		// Autorisation interruptions des periphriques
}
//**********************************************************************************************









//**********************************************************************************************
// Programme principal 
//**********************************************************************************************
void main(void)
{
    InitGeneral();
    
    while(1)
    {
        USBTasks();         	// USB Tasks
        Principal();
	}							//end while
}								//end main
//**********************************************************************************************





